目录
③力扣127. 单词接龙
解析代码
③力扣127. 单词接龙
127. 单词接龙
难度 困难
字典 wordList
中从单词 beginWord
和 endWord
的 转换序列 是一个按下述规格形成的序列 beginWord -> s1 -> s2 -> ... -> sk
:
- 每一对相邻的单词只差一个字母。
- 对于
1 <= i <= k
时,每个si
都在wordList
中。注意,beginWord
不需要在wordList
中。 sk == endWord
给你两个单词 beginWord
和 endWord
和一个字典 wordList
,返回 从 beginWord
到 endWord
的 最短转换序列 中的 单词数目 。如果不存在这样的转换序列,返回 0
。
示例 1:
输入:beginWord = "hit", endWord = "cog", wordList = ["hot","dot","dog","lot","log","cog"] 输出:5 解释:一个最短转换序列是 "hit" -> "hot" -> "dot" -> "dog" -> "cog", 返回它的长度 5。
示例 2:
输入:beginWord = "hit", endWord = "cog", wordList = ["hot","dot","dog","lot","log"] 输出:0 解释:endWord "cog" 不在字典中,所以无法进行转换。
提示:
1 <= beginWord.length <= 10
endWord.length == beginWord.length
1 <= wordList.length <= 5000
wordList[i].length == beginWord.length
beginWord
、endWord
和wordList[i]
由小写英文字母组成beginWord != endWord
wordList
中的所有字符串 互不相同
class Solution {
public:
int ladderLength(string beginWord, string endWord, vector<string>& wordList) {
}
};
解析代码
和力扣433. 最小基因变化一样,如果将每次字符串的变换抽象成图中的两个顶点和一条边的话,问题就变成了边权为 1 的最短路问题。 因此,从起始的字符串开始,来一次 bfs 即可。
class Solution {
public:
int ladderLength(string beginWord, string endWord, vector<string>& wordList) {
unordered_set<string> wordListHash(wordList.begin(), wordList.end());
unordered_set<string> vis;
if(!wordListHash.count(endWord))
return 0;
int ret = 1;
queue<string> q;
q.push(beginWord);
vis.insert(beginWord);
while(!q.empty())
{
++ret;
int size = q.size();
while(size--)
{
string t = q.front();
q.pop();
for(int i = 0; i < t.size(); ++i)
{
for(char ch = 'a'; ch <= 'z'; ++ch)
{
string tmp = t;
tmp[i] = ch;
if(wordListHash.count(tmp) && !vis.count(tmp))
{
if(tmp == endWord)
return ret;
q.push(tmp);
vis.insert(tmp);
}
}
}
}
}
return 0;
}
};